--- pristine_ast_trunk/pbx.c	2006-06-13 09:42:42.000000000 -0500
+++ digium_trunk/pbx.c	2006-06-13 13:44:42.000000000 -0500
@@ -1398,16 +1398,26 @@
 
 int ast_func_read(struct ast_channel *chan, char *function, char *workspace, size_t len)
 {
-	char *args = func_args(function);
-	struct ast_custom_function *acfptr = ast_custom_function_find(function);
+	int result = -1;
+	char *temp_function = NULL, *args = NULL;
+	struct ast_custom_function *acfptr;
+
+	if (ast_strlen_zero(function))
+		return -1;
+
+	temp_function = ast_strdup(function);
+	args = func_args(temp_function);
+	
+	acfptr = ast_custom_function_find(temp_function);
 
 	if (acfptr == NULL)
-		ast_log(LOG_ERROR, "Function %s not registered\n", function);
+		ast_log(LOG_ERROR, "Function %s not registered\n", temp_function);
 	else if (!acfptr->read)
-		ast_log(LOG_ERROR, "Function %s cannot be read\n", function);
-	else
-		return acfptr->read(chan, function, args, workspace, len);
-	return -1;
+		ast_log(LOG_ERROR, "Function %s cannot be read\n", temp_function);
+	else 
+		result = acfptr->read(chan, temp_function, args, workspace, len);
+	
+	return result;
 }
 
 int ast_func_write(struct ast_channel *chan, char *function, const char *value)
